# This program tries to steal running threads from other processes.
#
# Version 1.0: Steals threads usually, but sometimes they land on
#              the data instead of the jump and die.
# Version 1.1: Now threads are locked in place on first pass, then
#              taken.  They still get bored in the chamber though.
# Version 1.2: Slave threads spawn lots of threads to slow down
#              the rest of the process.  Makes for easier capture.
#

            title  "Owned 1.2"
            author "Logan Bauer <Logan.Bauer@Bigfoot.com>"


locator:    data    0
source:     data    0
dest:       data    0
take:       data    0
zero:       data    0
maxthreads: data    0
time:       data    1000

Start:      info    6, maxthreads
            div     2, maxthreads   # Limit slave count.

Find:       info    2, locator
            equal   zero, [locator]
            jump    CheckTime
            own     [locator]
            jump    CheckTime
            jump    StartTrap   # Enemy found.

# After a good while kill all the slaves.
CheckTime:  loop    time, Find

            info    5, time
            less    30000, time
            move    zero, Chamber   # SQUISH

            move    1000, time
            jump    Find


# Lock all threads in place.

StartTrap:  move    locator, dest
TrapLeft:   move    lock1, [dest]
            add     1, dest
            move    lock2, [dest]
            add     -3, dest
            equal   zero, [dest]
            jump    StartRight
#            own     [dest]
#            jump    StartRight
            jump    TrapLeft

StartRight: add     3, dest
            move    dest, take  # save starting trap spot.

            move    locator, source
            move    source, dest
            add     2, dest
TrapRight:  equal   zero, [dest]
            jump    Take
#            own     [dest]
#            jump    Take
            movei   source, dest
            movei   source, dest
            jump    TrapRight

# Now copy the code to steal the tread.
# Copy trap2 first so that when trap1 is copied it can
# execute correctly.

Take:       move    trap2, [take]
            add     -1, take
            move    trap1, [take]
            add     3, take
            own     [take]
            jump    Take
            jump    Find

# First position thread in lock1 so that it will not
# execute the data cell when trap2 is copied.
lock1:      jump    lock1
lock2:      jump    lock1

# Then force the thread to come here.
trap1:      jump    [trap2]
trap2:      data    &Chamber


# Let the slave die of boredom.
#Chamber:    jump    Chamber

# Make threads slow down the rest of their process for
# easier capture.
Chamber:    info    4, threads
            less    threads, maxthreads
            fork    Chamber
            jump    Chamber

            data    0
            data    0
            data    0
            data    0

# This will get overwritten oftern by the main code, but that is ok.
threads:    data    0
