#
# Pong Launcher 4 Directions
#

title "Pong Launcher 4D"
author "Benot Timbert <Benoit.Timbert@enst-bretagne.fr>"

C:	data 0	# random choice
P:	data &C  # missile position
D:	data &E	# missile direction address
C2:	data 0	# 1/2 mem size
C4:	data 0	# 1/4 mem size
# directions
E:	data 1
S:	data 0
O:	data -1
N:	data 0
E2:	data 1
S2:	data 0
O2:	data -1
INIT:	info 1,S
	neg S, N
	move 1, E
	move -1, O
	move S, S2
	move 1, E2
	move -1, O2
	fork CLONER
	move &C, P
	move &E, D
	info 0, C2
	div 2, C2
	move C2, C4
	div 2, C4
MLOOP:	own [P]
	jump MMOVE
	info 2, [P]
MMOVE:	add [D], P
	equal [P], 0
	jump MLOOP
	info 2, C
	less C2, C
	jump MLOOP
	less C, C4
	jump SUB
	add 1,D
	equal &INIT, D
	move &E, D
	jump MLOOP
SUB:	add -1,D
	equal &C4, D
	move &O2, D
	jump MLOOP		
CLONER:	info 4, TC
	less 6, TC	# Approx 4 couples of thread
	jump RESCAN
	info 2, R
	own [R]
	jump CLONER
	move &INIT, SA
	move R, DA
	move 54, CS
CLOOP:	movei SA, DA
	loop CS, CLOOP
	fork [R]
RESCAN: 	move &INIT, SA
	move 54, CS
RLOOP:	own [SA]
	jump RNEXT
	move BOMB, MMOVE	# unsafe, self destruction
BOMB:	div 0, R
RNEXT:	add 1, SA
	loop CS, RLOOP							
	jump CLONER
CS:	data 54		# interestion code size
TC:	data 0		# Thread count
SA:	data &INIT	# source address
DA:	data 0		# destination address
R:	data 0		# random address
