#
# Forest of clovers
#

title "Clover of Death Forest"
author "Benot Timbert <Benoit.Timbert@free.fr>"

# vars
t:	jump m		# target
u:	fork [l]	# up / thread count / copy source
l:	fork [d]	# left / copy destination
d:	fork [r]	# down / copy count
r:	fork [u]	# right
b:	fork [b]	# fork bomb
m:	move 4, m	# max number of thread : 4
w:	info 1, w	# width
n:	neg w, n	# -width

main:	info 2, t	# main loop
	info 4, u
	less m, u
	jump strike
	
sfork:	move &t, u	# self forking
	move t, l
	move 44, d	# program is 44 long
cloop:	own [l]		# copy loop
	jump main
	movei u, l
	loop d, cloop
	add 9, t	# jump the 9 vars
	fork [t]
	jump main
	
strike:	move t, u	# strike a death clover
	add n, u
	own [u]
	jump main
	move t, l
	add 1, l
	own [l]
	jump main
	move t, d
	add w, d
	own [d]
	jump main
	move t, r
	add -1, r
	own [r]
	jump main
	move b, [u]
	move b, [l]
	move b, [d]
	move b, [r]
	jump main
