	title	"Basic Replicator"
	author	"Jeff Morrow <jmorrow@alum.mit.edu>"

START:		info 2, DEST		# Get a random location
		move 18, COUNT		# Bytes to copy
		move DEST, DESTSTART

CLOBBER:	own [DEST]
		jump START		# If we already own the location, skip
		movei SRC, DEST
		loop COUNT, CLOBBER

		info 6, MAX		# If we did a complete clobber
					# and we're not at the max number
					# of threads, fork the new guy
		info 4, THREADS
		less THREADS, MAX
		fork [DESTSTART]
		jump START

SRC:		data &START
DEST:		data 0
DESTSTART:	data 0
COUNT:		data 0
MAX:		data 0
THREADS:	data 0
